import { warehouseList } from '@/api/warehouse'
const warehouse = {
  template: `
      <a-select
        :placeholder="placeholder"
        :id="id"
        allowClear
        :value="defaultVal"
        :showSearch="true"
        :disabled="disabled"
        :mode="modeType"
        @change="handleChange"
        :filter-option="filterOption">
        <a-select-option v-for="item in warehouseData" :key="item.warehouseSn" :value="item.warehouseSn">{{ item.name }}</a-select-option>
      </a-select>
    `,
  props: {
    value: {
      type: String,
      defatut: ''
    },
    id: {
      type: String,
      default: ''
    },
    placeholder: {
      type: String,
      default: '请选择仓库'
    },
    disabled: {
      type: Boolean,
      default: false
    },
    modeType: {
      type: String,
      default: 'default'
    }
  },
  data () {
    return {
      defaultVal: this.value,
      warehouseData: [],
      pageNo: 1,
      pageSize: 1000
    }
  },
  mounted () {
    this.getWarehouse()
  },
  watch: {
    value (newValue, oldValue) {
      this.defaultVal = newValue
    }
  },
  methods: {
    filterOption (input, option) {
      return (
        option.componentOptions.children[0].text.toLowerCase().indexOf(input.toLowerCase()) >= 0
      )
    },
    handleChange (value) {
      this.defaultVal = value
      this.$emit('input', value)
      this.$emit('change', value)
    },
    //  获取仓库列表
    getWarehouse () {
      warehouseList({ pageNo: 1, pageSize: 1000 }).then(res => {
        if (res.status == 200) {
          this.warehouseData = res.data.list
        } else {
          this.warehouseData = []
        }
      })
    }
  }
}

export default warehouse
